/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic.graph.impl;

import java.util.HashMap;
import java.util.Map;
import javax.annotation.Nonnull;

/**
 *
 * @author fritz
 */
public class NamespaceManager
  {
    private final Map<String, String> map = new HashMap<String, String>();

    public NamespaceManager()
      {
        // FIXME: move them to a specific configuration
        map.put("http://www.w3.org/1999/02/22-rdf-syntax-ns", "rdf");
        map.put("http://www.w3.org/2000/01/rdf-schema", "rdfs");
        map.put("http://www.w3.org/2000/10/XMLSchema", "xsd");
        map.put("http://purl.org/dc/elements/1.1/", "dc:");
        map.put("http://jay.askren.net/gedcom/rdf", "ged:");
        map.put("http://www.daml.org/2001/01/gedcom/gedcom", "daml");
        map.put("http://www.syr.edu/2008/12/28-vrc/vrc", "vrc");
        map.put("http://xmlns.com/foaf/0.1/", "foaf:");
        map.put("http://xmlns.com/wot/0.1/", "wot");
        map.put("http://www.w3.org/2003/01/geo/wgs84_pos", "geo");
        map.put("http://www.w3.org/2000/10/swap/pim/contact", "contact:");
        map.put("http://www.w3.org/ns/auth/cert", "cert");
        map.put("http://www.w3.org/ns/auth/rsa", "rsa");
        map.put("http://www.iana.org/assignments/relation/", "iana:");
        map.put("http://bblfish.net/work/atom-owl/2006-06-06/", "awol");
      }

    public String resolveURI (@Nonnull final String uri)
      {
        for (final Map.Entry<String, String> entry : map.entrySet())
          {
            if (uri.startsWith(entry.getKey()))
              {
                return uri.replaceFirst(entry.getKey(), entry.getValue());
              }
          }
        
        return uri;
      }
  }
